<?php
// $Id: xc_search_block.inc,v 1.1.2.48 2010/09/16 21:11:37 pkiraly Exp $

/**
 * @file
 * functions used for handlink blocks near the search result list, or the
 * full display
 */

function xc_search_block_facets($current_path) {
  global $_xc_search_server, $base_path;
  include_once(drupal_get_path('module', 'xc_solr') . '/XCGap.php');
  
  $search_path = $_GET['q'];
  
  $query = xc_search_current_query();
  $ui = xc_search_current_ui();
  if(empty($ui)) {
    $ui = xc_search_ui_get($_GET['search_ui']);
  }
  $is_prepopulated = FALSE;
  if (empty($query)) {
    if($ui->do_prepopulate_facets == 1) {
      $is_prepopulated = TRUE;
      $query = '*:*';
    }
    else {
      return;
    }
  }
  $active_filters = empty($_GET['filter']) ? array() : array_unique($_GET['filter']);
  
  $xc_statistics_enabled = module_exists('xc_statistics');
  if ($xc_statistics_enabled) {
    $t_start = microtime(TRUE);
    $statistics = array(
      'ui_id'   => $ui->sui_id,
      'ui_name' => $ui->name,
      'query'   => $query . '?' . http_build_query($active_filters),
    );
  }

  $blocks['subject'] = t('Faceted navigation');
  if ($query != '*:*' 
      && !preg_match('/^(xc__workExpressed_t|xc__expressionManifested_t|id|):/', 
          $query)) {
    // TODO: create a better display than raw Solr query
    
    /*
    $blocks['content'] = t('The query is: %query', array(
      '%query' => xc_search_display_query($query)
    ));
    */
  }
  $facet_group = xc_search_facet_group_load($ui->facet_id);
  if(empty($facet_group)) {
    return;
  }
  $facet_objects = xc_search_facets_by_group($ui->facet_id);
  if(empty($facet_objects)) {
    return;
  }
  $default_field_params = xc_search_field_facet_properties_load(
    $facet_group->attribute_set_id
  );
  
  $params = array(
    'facet'          => 'true',
    'facet.limit'    => $default_field_params->limitation,
    'facet.mincount' => $default_field_params->mincount,
  );

  $collections = array(
    'active_filters' => $active_filters,
    'facets' => array(),
  );
  xc_search_block_facets_to_parameters($facet_objects, $params, $collections);
  
  $search_type = !empty($_GET['search_type']) ? $_GET['search_type'] : 'standard';
  if ($search_type == 'standard') {
    if (!in_array('type:manifestation', $active_filters)) {
      $active_filters[] = 'type:manifestation';
    }
  }
  if (!empty($active_filters)) {
    $params['fq'] = $active_filters;
  }

  $base_link = $base_path . $current_path;
  $no_query_path = $base_link;
  $non_filter_params = array();
  if (strstr($current_path, '?')) {
    $no_query_path   = preg_replace('/\?.*$/', '', $current_path);
    $no_filters_path = preg_replace('/\?.*$/', '?', $base_link);
    $appended = FALSE;
    foreach ($_GET as $key => $value) {
      if ($key != 'q' && $key != 'filter') {
        if ($appended == FALSE) {
          $appended = TRUE;
        }
        else {
          $no_filters_path .= '&';
        }
        if ($key != 'page') {
          $no_filters_path .= $key . '=' . $value;
          $non_filter_params[$key][] = $value;
        }
      }
    }
  }
  
  $field_limit_modifiers = array();
  if (!empty($active_filters)) {
    $filter_list = array();
    foreach ($active_filters as $filter) {
      
      // skipp
      if (preg_match('/^type:/', $filter)) {
        continue;
      }
      $current_non_filter_params = $non_filter_params;

      // creating remove link
      $other_filters = array_diff($active_filters, array($filter));

      // creating label
      list($facet_field, $facet_term) = split(':', $filter, 2);
      $field_limit_modifiers[$facet_field][] = preg_replace('/^"|"$/', '', $facet_term);

      // field name to display
      $label = isset($collections['facets'][$facet_field])
        ? $collections['facets'][$facet_field]['label']
        : $facet_field;
      $label .= ': ';

      if ($collections['facets'][$facet_field]['type'] == 'facet_dates') {
        unset($current_non_filter_params['date_df_gap']);
      }
      // get the value to display
      if (isset($collections['facets'][$facet_field]['type'])) {
        $label = xc_seach_block_get_label(
          $collections['facets'][$facet_field]['type'], 
          $facet_term, 
          $collections['facets'][$facet_field]['label']);
      }
      else if (isset($collections['subject_facets'][$facet_field]['type'])) {
        $label = xc_seach_block_get_label(
          $collections['subject_facets'][$facet_field]['type'], 
          $facet_term, 
          $collections['subject_facets'][$facet_field]['label']
        );
      }
      // hidden facets
      else {
        
      }

      $filter_list[] = theme('xc_search_block_filter', 
         $search_path, $label, array_merge($current_non_filter_params, 
           array('filter' => $other_filters)));
    } // foreach $active_filters
    if (!empty($filter_list)) {
      $blocks['content'] .= '<div id="xc-search-active-filters">'
        . theme('item_list', $filter_list, t('Active filters'))
        . '</div>';
    }
  } // !empty($active_filters
  
  foreach($field_limit_modifiers as $facet_field => $terms) {
    $param_name = 'f.' . $facet_field . '.facet.limit';
    $default_limit = isset($params[$param_name]) ? $params[$param_name] 
      : $params['facet.limit'];
    $params[$param_name] = $default_limit + count($terms);
  }
  // add +2 to format_fc
  $param_name = 'f.format_fc.facet.limit';
  $default_limit = isset($params[$param_name]) ? $params[$param_name] : $params['facet.limit'];
  $params[$param_name] = $default_limit + 2;
  
  $checkbox_opts = array(
    'online_only' => (isset($_GET['online_only'])
                  ?  (intval($_GET['online_only']) == 1 ? 1 : 0) : 0),
    'exclude_microform' => (isset($_GET['exclude_microform']) 
                        ? (intval($_GET['exclude_microform']) == 1 ? 1 : 0) : 1)
  );
  
  if($search_type == 'standard' && $checkbox_opts['online_only'] == 1) {
    $params['fq'][] = 'format_fc:"Online"';
  }
  if($search_type == 'standard' && $checkbox_opts['exclude_microform'] == 1) {
    $params['fq'][] = 'format_fc:"Not microform"';
  }
  
  if ($xc_statistics_enabled) {
    $statistics['prepare'] = microtime(TRUE) - $t_start;
    $t_solr = microtime(TRUE);
  }
  //$params['debugQuery'] = 'on';
  // dsm($params);
  $response = $_xc_search_server->search($query, 0, 0, $params, FALSE);
  // dsm($response->facet_counts);
  
  //xc_util_dsm($response->responseHeader->QTime);
  //xc_util_dsm($response->debug->timing);
  //xc_util_dsm($response->debug->process);
  if ($xc_statistics_enabled) {
    $statistics['hits'] = $response->response->numFound;
    $statistics['solr_all'] = microtime(TRUE) - $t_solr;
    $statistics['solr'] = $response->responseHeader->QTime / 1000;
    $t_display = microtime(TRUE);
  }

  
  // DISPLAY each facets
  $options = array(
    'search_path'        => $search_path,
    'active_filters'     => $active_filters,
    'non_filter_params'  => $non_filter_params,
    'is_prepopulated'    => $is_prepopulated,
    'field_limit_modifiers' => $field_limit_modifiers,
  );

  $checkboxes = array(
    'online'    => array('online_only',    t('online only')),
    'microform' => array('exclude_microform', t('exclude microform'))
  );
  $blocks['content'] .= '<div id="xc-search-facet-checkboxes">';
  foreach ($checkboxes as $key => $checkbox) {
    list($option_key, $label) = $checkbox;
    $checkbox_state = $checkbox_opts[$option_key];
    $active_filters = $options['active_filters'];
    $urls = array();
    for ($i=1; $i<=2; $i++) {
      $non_filter_params = $options['non_filter_params'];
      if(isset($non_filter_params[$option_key])) {
        unset($non_filter_params[$option_key]);
      }
      $non_filter_params[$option_key] = ($i == 1) ? 1 : 0;
      $path = $options['search_path'];
      if ($options['is_prepopulated'] == TRUE) {
        $path .= '/' . $query;
      }
      $url_query_params = array_merge(
        $non_filter_params,
        array('filter' => array_unique($active_filters))
      );
      $urls[] = url($path, array('query' => xc_clean_params($url_query_params), 'absolute' => FALSE));
    }
    $id = 'xc_search_facet_checkbox_' . $key;
    $blocks['content'] .= '<input type="checkbox"'
      . ' id="' . $id . '"'
      . ' onclick="document.location=(this.checked == true) ? \'' . $urls[0] . '\' : \'' . $urls[1] . '\'"'
      . ($checkbox_state ? ' checked="checked"' : '')
      . '/>'
      . '<label for="' . $id . '">' . $label . '</label><br/>';
  }
  $blocks['content'] .= '</div>';
  $query_url = preg_match('/\?/', $current_path) ? preg_replace('/^.*\?/', '', $current_path) : '';
  
  // $facet_objects
  $hidden_facets = '';
  $normal_facets = '';
  foreach ($collections['facets'] as $field => $facet) {
    $type  = $facet['type'];

    // get field facets
    if ($type == 'facet_fields' 
        && isset($response->facet_counts->$type)
        && isset($response->facet_counts->$type->$field)) {
      if($field == 'format_fc') {
        $links = xc_search_block_get_facet_fields($field, $facet['label'],
          $response->facet_counts->$type->$field, 
          array_merge($options, 
            array('exclude' => array('Not online', 'Not microform'))));
      }
      else {
        $links = xc_search_block_get_facet_fields($field, $facet['label'],
          $response->facet_counts->$type->$field, $options);
      }
      if (!empty($links)) {
        $param_name = 'f.' . $field . '.facet.limit';
        $default_limit = isset($params[$param_name]) 
          ? $params[$param_name] 
          : $params['facet.limit'];
        if(isset($field_limit_modifiers[$field])) {
          $default_limit -= count($field_limit_modifiers[$field]);
        }
        if (count($links) >= $default_limit) {
          $links[] = l('More', 'admin/xc/search/more_facets', 
            array(
              'query' => $query_url . '&query=' . $query . '&facet=' . $field,
              'attributes' => array('class' => 'xc-search-facet-more-link')
            )
          );
        }
      }
    }

    // get date facets
    elseif ($type == 'facet_dates') {
      // get date query facets before
      $links = array();
      $links = array_merge($links, xc_search_block_get_date_facet_query_links($field,
        $response, $collections, $options, 'before'));
        
      $links = array_merge($links, xc_search_block_get_date_facet_query_links($field,
        $response, $collections, $options, 'main'));
      /*
      $links = array_merge($links, xc_search_block_get_facet_dates($field, 
        $facet['label'], $response->facet_counts->$type->$field, $options));
      */

      // get after date query facets
      $links = array_merge($links, xc_search_block_get_date_facet_query_links($field, 
        $response, $collections, $options, 'after'));
    }
    
    // TODO: facet_queries
    elseif ($type == 'facet_queries') {
    
    }

    // theming links
    if (!empty($links)) {
      $id = 'fieldset-' . $field;
      $collapsed = module_exists('fieldset_helper') 
        ? fieldset_helper_state_manager_get_state($id, $facet['is_collapsed'])
        : $facet['is_collapsed'];
      $fieldset = array(
        '#title' => $facet['label'],
        '#attributes' => array('id' => $id),
        '#collapsible' => TRUE,
        '#collapsed' => $collapsed,
        '#value' => theme('item_list', $links),
        '#attributes' => array('class' => 'xc-search-facet'),
      );
      $facet_list = theme('fieldset', $fieldset);
      if (in_array($field, $collections['hidden_facets'])) {
        $hidden_facets .= $facet_list;
      }
      else {
        $normal_facets .= $facet_list;
      }
    }
  }
  $blocks['content'] .= $hidden_facets . $normal_facets;
  
  if ($xc_statistics_enabled) {
    $statistics['display'] = microtime(TRUE) - $t_display;
    $statistics['total'] = microtime(TRUE) - $t_start;
    xc_statistics_save('facet', $statistics);
  }
  return $blocks;
}

/**
 * Get the list of field type facets as links
 * @param $field (string)
 *   The name of field
 * @param $field_label (string)
 *   The human readable field name
 * @param $terms (array)
 *   The facet terms. Its items are array or term and count number.
 * @param $options (Array)
 *   An associative array of parameters.
 *     'search_path' - (String) The current path with search term
 *     'active_filters'     - (Array) Active filters
 *     'non_filters_params' - (Array) Other parameters in URL, which are not filters
 *     'is_prepopulated' - (Boolean) Flag showing whether the facets created 
 *       as prepopulated (without query term), or not
 * @return (Array)
 *   List of links which could filter the current search
 */
function xc_search_block_get_facet_fields($field, $field_label, $terms, $options) {
  foreach ($terms as $term => $count) {
    // skip the active filters
    if(isset($options['field_limit_modifiers'][$field])
        && in_array($term, $options['field_limit_modifiers'][$field])) {
      continue;
    }
    if(isset($options['exclude']) && in_array($term, $options['exclude'])) {
      continue;
    }
    
    $query = $field . ':"' . $term . '"';
    $path = $options['search_path'];
    if ($options['is_prepopulated'] == TRUE) {
      $path .= '/*'; // . $query;
    }
    $url_query_params = array_merge(
      $options['non_filter_params'], 
      array('filter' => array_merge($options['active_filters'], array($query)))
    );
    $filter_by_label = $field_label . ' = ' . $term;
    $links[] = theme('xc_search_block_facet_link', $term, $count, $path, 
      $filter_by_label, $url_query_params);
  }
  return $links;
}

/**
 * Creates a date query facet link.
 * 
 * @param $query (String)
 *   The Solr query
 * @param $label (String)
 *   The label of the link
 * @param $count (int)
 *   The number of documents belongs to this facet term
 * @param $options (Array)
 *   General information and URL parameters
 * 
 * @return (String)
 *   The link
 */
function xc_search_block_get_facet_query_link($query, $label, $count, $options) {
  if(empty($label)) {
    $label = xc_seach_block_get_label('facet_queries', $query);
  }
  
  $path = $options['search_path'];
  if ($options['is_prepopulated'] == TRUE) {
    $path .= '/*'; // . $query;
  }
  $url_query_params = array_merge(
    $options['non_filter_params'], 
    array('filter' => array_merge($options['active_filters'], array($query)))
  );
  
  return theme('xc_search_block_facet_link', $label, $count, $path, $label, $url_query_params);
}

/**
 * Collects links displaying before and after the main date facet.
 * 
 * @param $field (String)
 *   The Solr field name which is the base of the facet
 * @param $response (Object)
 *   The Solr response
 * @param $collections (Array)
 *   General informations about facets and facet properties
 * @param $options (Array)
 *   Link options, holding general additional information
 * @param $position (String)
 *   The position of the links relative to the main date facet: 'before' or 'after'.
 */
function xc_search_block_get_date_facet_query_links($field, &$response, &$collections, 
    $options, $position = 'after') {

  $links = array();
  /*
  if(in_array($field, array_keys($options['field_limit_modifiers']))) {
    dsm('return');
    return $links;
  }
  */
  
  $gap_str = $_GET[$field . '_gap'];
  if(empty($gap_str)) {
    $gap_str = $collections['facets'][$field]['params']->gap;
  }
  $gap = new XCGap($gap_str);
  foreach ($options['active_filters'] as $i => $filter) {
    if(preg_match('/^' . $field . ':/', $filter)) {
      unset($options['active_filters'][$i]);
    }
  }

  switch($position) {
    case 'before':
    case 'after':
      // get the additional date queries for this field at this position
      $queries =& $collections['date_facet_query_display_map'][$field][$position];
      if(!empty($queries)) {
        // order by weight
        ksort($queries);
        foreach($queries as $weight => $queryObj) {
          $options['non_filter_params'][$field . '_gap'] = $queryObj->gap;
          $query = $field . ':' . $queryObj->query;
          if(!in_array($query, $options['active_filters'])
              && $response->facet_counts->facet_queries->$query > 0) {
            $links[] = xc_search_block_get_facet_query_link($query, $queryObj->label, 
              $response->facet_counts->facet_queries->$query, $options);
          }
        }
      }
      break;
    case 'main':
    default:
      // get the otherwise handled queries
      $handled_queries = array();
      $handled_query_objects = array();
      foreach(array('before', 'after') as $key) {
        if(is_array($collections['date_facet_query_display_map'][$field][$key])) {
          $handled_query_objects += array_values(
            $collections['date_facet_query_display_map'][$field][$key]);
        }
      }
      if(!empty($handled_query_objects)) {
        foreach ($handled_query_objects as $queryObj) {
          $handled_queries[] = $field . ':' . $queryObj->query;
        }
      }
      $gap->scale_down();
      $options['non_filter_params'][$field . '_gap'] = $gap->text;
      
      // iterate over the facet queries
      foreach ($response->facet_counts->facet_queries as $query => $count) {
        if($count > 0 && !in_array($query, $handled_queries)) {
          if(preg_match('/^' . $field . ':(.*)$/', $query, $matches) !== FALSE) {
            $links[] = xc_search_block_get_facet_query_link($query, 
              xc_search_date_query_label($field, $matches[1], $collections),
              $count, $options);
          }
        }
      }
  }
  return $links;
}

function xc_search_date_query_label($field, $query, &$collections) {
  $gap_str = $_GET[$field . '_gap'];
  if(empty($gap_str)) {
    $gap_str = $collections['facets'][$field]['params']->gap;
  }
  $gap = xc_solr_parse_gap($gap_str);
  $value = preg_replace('/^(\[|\{)|(\]|\})$/', '', $query);
  list($from, $to) = split(' TO ', $value);
  $from = substr($from, 0, $gap->date_part_length);
  $to = substr($to, 0, $gap->date_part_length);
  $label = ($from != $to) ? $from . '-' . $to : $from;

  return $label;
}
/**
 * Get the list of date type facets as links
 * @param $field (string)
 *   The name of field
 * @param $field_label (string)
 *   The human readable field name
 * @param $terms (array)
 *   The facet terms. Its items are array or term and count number.
 * @param $options (Array)
 *   An associative array of parameters.
 *     'search_path' - (String) The current path with search term
 *     'active_filters'     - (Array) Active filters
 *     'non_filters_params' - (Array) Other parameters in URL, which are not filters
 *     'is_prepopulated' - (Boolean) Flag showing whether the facets created 
 *       as prepopulated (without query term), or not
 * @return (Array)
 *   List of links which could filter the current search
 */
function xc_search_block_get_facet_dates($field, $field_label, $terms, $options) {
  static $unhandled_values;
  
  $links = array();

  if(empty($unhandled_values)) {
    $unhandled_values = array('gap', 'end', 'before', 'after', 'between');
  }
  
  $date_filters = xc_search_remove_date_filter($options['active_filters'], $field);
  $keys = array_keys(get_object_vars($terms));
  
  // parsing gap
  $gap = xc_solr_parse_gap($terms->gap);
  
  // iterate over terms
  for ($i = 0; $i < count($keys); $i++) {
    $term  = $keys[$i];
    $count = $terms->$term;
    
    if (in_array($term, $unhandled_values)) {
      continue;
    }
    // there is no terms
    if ($count == 0) {
      continue;
    }
    if (preg_match('/^\d{4}-/', $keys[$i+1])) {
      $next = $keys[$i+1]; //xc_solr_date_modify($keys[$i+1], '-1 second');
    }
    else {
      $next = $terms->end;
    }
    if($gap !== FALSE) {
      if($gap->date_part_length > 0) {
        $first_date  = substr($term,  0, $gap->date_part_length);
        $second_date = substr($next, 0, $gap->date_part_length);
        $term_label = ($first_date != $second_date)
          ? $first_date . '-' . $second_date
          : $first_date;
      }
      else {
        $term_label = $term . '-' . $next;
      }
    }
    else {
      $term_label = $term;
    }
    $query = $field . ':[' . $term . ' TO ' . $next . ']';
    $path = $options['search_path'];
    if ($options['is_prepopulated'] == TRUE) {
      $path .= '/*'; // . urlencode($query);
    }
    $url_query_params = array_merge(
      $options['non_filter_params'],
      array(
        'filter' => array_merge($date_filters, array($query)),
        $field . '_gap' => $terms->gap
      )
    );
    $links[] = theme('xc_search_block_facet_link', $term_label, $count, $path, 
      $query, $url_query_params);
  }
  return $links;
}

/**
 * Get displayable label based on facet term.
 * 
 * @param $type (String)
 *   The type of facet ('facet_fields' or 'facet_dates' or 'facet_queries')
 * @param $facet_term (String)
 *   The facet term
 *   
 * @return (String)
 *   The display label of the facet
 */
function xc_seach_block_get_label($type, $facet_term, $field_label = NULL) {
  $label = '';
  switch ($type) {
    case 'facet_fields':
      $label = preg_replace('/^"|"$/', '', $facet_term);
      break;
    
    case 'facet_dates':
      $value = preg_replace('/^\[|\]$/', '', $facet_term);
      list($from, $to) = split(' TO ', $value);
      $from = substr($from, 0, 4);
      $to = substr($to, 0, 4);
      $label = ($from != $to) ? $from . '-' . $to : $from;
      break;
    
    case 'facet_queries':
      $value = preg_replace('/^\[|\]$/', '', $facet_term);
      $value_parts = split(' TO ', $value);
      $label = join('-', $value_parts);
      break;
  }
  if(!is_null($field_label)) {
    $label = $field_label . ': ' . $label;
  }
  return $label;
}

/**
 * Process facet information come from database, and creates URL parameters for
 * Solr. 
 * 
 * It also fill up the general collection array about facets, and the 
 * additional date query facets.
 * 
 * @param $facet_objects (Array)
 *   List of facet object
 * @param $params (Array)
 *   Reference to URL parameters
 * @param $collections
 *   Reference to general collections
 */
function xc_search_block_facets_to_parameters($facet_objects, &$params, &$collections) {
  $type_map = array(
    'query' => 'facet_queries',
    'date'  => 'facet_dates',
    'field' => 'facet_fields',
  );
  $subjects = array('subject_topic', 'subject_spatial', 'subject_temporal');
  foreach ($subjects as $subject) {
    $index_facet = xc_index_facet_load_by_name($subject);
    $field = $subject . $index_facet->type;
    $collections['subject_facets'][$field] = array(
      'type' => 'facet_fields',
      'field' => $field,
      'label' => t($index_facet->label),
      'is_collapsed' => 1,
    );
  }
  
  foreach ($facet_objects as $facet) {
    $index_facet = xc_index_facet_load_by_name($facet->name);
    $field = $facet->name . $index_facet->type;
    $collections['facets'][$field] = array(
      'type' => $type_map[$facet->type],
      'field' => $field,
      'label' => t($index_facet->label),
      'is_collapsed' => $facet->is_collapsed,
    );
    if($facet->type == 'field') {
      $params['facet.field'][] = $field;
    }
    if(isset($facet->attribute_set_id) && $facet->attribute_set_id != 0) {
      $field_params = xc_search_get_attribute_set($facet->type, $facet->attribute_set_id);
      $collections['facets'][$field]['params'] = $field_params;
      if($facet->type == 'date') {
        foreach($collections['active_filters'] as $filter) {
          if (preg_match('/^' . $field . ':[\{\[]([^ ]+) TO ([^ ]+)[\]\}]$/', $filter, $matches)) {
            $field_params->start = $matches[1];
            $field_params->end = $matches[2];
            $field_params->gap = $_GET[$field . '_gap'];
            break;
          }
        }
      }
      
      $facet_params = xc_search_facet_properties2solr_params($facet->type, 
        $field_params, $field);
        
      // field base gap
      if($facet->type == 'date') {
        $current_gap = $_GET[$field . '_gap'];
        
        // get additional date quers facets
        include_once drupal_get_path('module', 'xc_search') 
          . '/displaying/xc_search_date_facet_properties.inc';
        $date_query_facets = xc_search_date_facet_properties_additionals_get_by_pid(
          $facet->attribute_set_id);
        if(!empty($date_query_facets)) {
          foreach ($date_query_facets as $date_query_facet) {
            $query = $field . ':' . $date_query_facet->query;
            $collections['date_facet_query_display_map'][$field]
              [$date_query_facet->position][$date_query_facet->weight] = 
                $date_query_facet;
            $facet_params['facet.query'][] = $query;
          }
        }
      }
      $params += $facet_params;
    }
  }
  
  // hidden
  $collections['hidden_facets'] = array();
  foreach($collections['active_filters'] as $filter) {
    if(preg_match('/^(\w+)_fc:"(.*?)"$/', $filter, $matches)) {
      // TODO: there is an assumption, that all such 'hidden' facets are
      // field facets
      $field_name = $matches[1];
      $index_facet = xc_index_facet_load_by_name($field_name);
      $field = $field_name . $index_facet->type;
      if (isset($collections['facets'][$field])) {
        continue;
      }
      $collections['hidden_facets'][] = $field;
      $collections['facets'][$field] = array(
        'type' => 'facet_fields',
        'field' => $field,
        'label' => t($index_facet->label),
        'is_collapsed' => FALSE,
      );
      $params['facet.field'][] = $field;
      /*
       * TODO: Now there is no facet info, but later...
      if(isset($facet->attribute_set_id) && $facet->attribute_set_id != 0) {
        $field_params = xc_search_get_attribute_set($facet->type, $facet->attribute_set_id);
        $collections['facets'][$field]['params'] = $field_params;
      }
      */
    }
  }
  
}

/**
 * Creating and theming a facet link
 * @param $term (String)
 *   The facet term to display
 * @param $count (int)
 *   The number of documents matching this term
 * @param $path (string)
 *   The query URL
 * @param $filter_by_label
 *   A label in title attribute of the link
 * @param $query_params (Array)
 *   The query part of the URL
 * @return (String)
 *   The facet link, which filters the content
 */
function theme_xc_search_block_facet_link($term, $count, $path, $filter_by_label, 
    $query_params) {
  return '<span class="xc-search-facet-link">' 
    . l('<span class="facet-term">' . t($term) . '</span>', $path, array(
        'attributes' => array('title' => t('Filter by \'!label\'', array('!label' => $filter_by_label))),
        'query' => xc_clean_params($query_params),
        'html' => TRUE
      ))
    . ' <span class="facet-term-count">(' . $count . ')</span></span>';
}

/**
 * Makes a remove filter link
 * @param $search_path (String)
 *   The Drupal path, like xc/search/query
 * @param $label (string)
 *   The displayed label of active filter, like 'Mozart, Wolfgang Amadeus, 1756-1791.'
 * @param $get_params (Array)
 *   Other URL parameters (the part of the URL after the ? sign)
 * @return (String)
 *   The string to display
 */
function theme_xc_search_block_filter($search_path, $label, $get_params = NULL) {
  $alt_text = t('Remove \'!label\' filter', array('!label' => $label));

  $image = l(
    theme('image', drupal_get_path('module', 'xc_search') . '/images/delete.png',
      $alt_text, $alt_text),
    $search_path,
    array(
      'attributes' => array(
        'title' => $alt_text,
        'class' => 'xc-search-active-filter-image'
      ),
      'query' => xc_clean_params($get_params),
      'html' => TRUE,
    )
  );
  
  $link = l($label, $search_path, array(
    'attributes' => array(
      'title' => $alt_text,
      'class' => 'xc-search-active-filter-link'
    ),
    'query' => xc_clean_params($get_params),
    'html' => TRUE,
  ));

  return '<span class="xc-search-active-filter">' . $image . $link . '</span>';
}

function xc_search_block_result_navigation($node_id) {
  global $_xc_search_server;
  
  // Only show for metadata returned with a hit created by
  // xc_search_get_full_display_url()

  if(!isset($_GET['hit']) || $_GET['hit'] < 1
      || !is_metadata_node(node_load($node_id))) {
    return;
  }
  if (isset($_GET['caller']) && $_GET['caller'] == 'xc-browse') {
    $caller_param = $_GET['caller'];
    $caller_module = 'xc_browse';
  }
  else {
    $caller_param = 'xc-search';
    $caller_module = 'xc_search';
  }
  
  list($query, $params, $rows_per_page, $total, $search_page) =
    $_SESSION['xc_search_query'][$caller_module];
  $hit = max(1, intval($_GET['hit']));
  $first = ($hit == 1) ? 0 : $hit - 2;
  $rows  = ($hit == $total || $first == 0) ? 2 : 3;
  $params['fl'] = 'dcterms__title_t,node_id_i';
  $response = $_xc_search_server->search($query, $first, $rows, $params, FALSE);

  $links = array();

  // Hit list
  $url = parse_url(urldecode($search_page));
  $page = intval(($hit-1) / $rows_per_page);

  if($page > 0) {
    $url['query'] = preg_replace('/((?:^|&)page=)\d+/', '${1}'.$page,
      $url['query'], -1, $count);
    if($count == 0) {
      $url['query'] .= '&page=' . $page;
    }
  }

  $links['list'] = l(t('Result List'), $url['path'], array(
    'query' => $url['query'],
    'fragment' => $url['fragment']
  ));

  // Previous
  if($hit > 1) {
    $doc = $response->response->docs[0];
    $links['prev'] = l(t('Previous Result'), 'node/' . $doc->node_id_i, array(
      'attributes' => array('title' => xc_util_conditional_join(' - ', $doc->dcterms__title_t)),
      'query' => array('hit' => ($hit-1), 'caller' => $caller_param),
      'html' => true,
    ));
  }

  // Next
  if($hit < $total) {
    $doc = $response->response->docs[$rows-1];
    $links['next'] = l(t('Next Result'), 'node/' . $doc->node_id_i, array(
      'attributes' => array('title' => xc_util_conditional_join(' - ', $doc->dcterms__title_t)),
      'query' => array('hit' => ($hit+1), 'caller' => $caller_param),
      'html' => true,
    ));
  }

  // Output
  return array(
    'subject' => '<none>',
    'content' => theme('xc_search_block_result_navigation', $links)
  );
}

function theme_xc_search_block_result_navigation($links) {
  return '<div id="xc-search-result-navigation">'
       . '<div class="result-nav result-prev">' . $links['prev'] . '</div>'
       . '<div class="result-nav result-next">' . $links['next'] . '</div>'
       . '<div class="result-nav result-list">' . $links['list'] . '</div>'
       . '</div>';
}

