<?php
// $Id: xc-search-result-list-row.tpl.php,v 1.1.2.15 2010/09/16 15:45:58 pkiraly Exp $

/**
 * @file templates/xc-search-result-list-row.tpl.php
 * Default theme implementation of a navigation bar on the browse admin UI
 * 
 * Available variables:
 * - $counter: the record counter
 * - $node_id: the node id
 * - $result: the result (from Search API)
 * - $xc_record: the full XC record

 * 
 * @see template_preprocess_xc_browse_admin_bar()
 */?>
<tr <?php print $attributes; ?>>

  <!-- checkbox -->
  <td class="checkbox">
    <input class="num-checkbox form-checkbox" type="checkbox" name="items"
       value="<?php print $node_id; ?>|<?php print $result['extra']['id']; ?>"/>
  </td>

  <!-- image -->
  <td class="coverart" id="coverart-<?php print $node_id; ?>">
      <a href="<?php print $result['link']; ?>">
        <?php if ($result['extra']['image_url']): ?>
          <img src="<?php print $result['extra']['image_url']; ?>" alt="<?php print t('Cover image'); ?>" title="<?php print t('Cover image'); ?>" />
        <?php else: ?>
          <img src="<?php print base_path() . drupal_get_path('module', 'xc_search') . '/images/blank-cover.gif'; ?>" alt="<?php print t('Cover image'); ?>" title="<?php print t('Cover image'); ?>"/>
        <?php endif; ?>
      </a>
  </td>

  <!-- counter, selector -->
  <td class="num">
    <?php print $counter; ?>
  </td>

  <!-- main data -->
  <td class="result <?php if ($result['extra']['highlight']): ?>has-highlight<?php endif; ?>">
    <?php if ($result['extra']['highlight']): ?>
      <div class="highlight-container">
        <div class="highlight">
          <?php print $result['extra']['highlight'] ?>
        </div>
      </div>
    <?php endif; ?>

    <?php print $result['title']; ?>
    <?php print $result['snippet']; ?>
  </td>

</tr>